scoreboard players reset gun_ammo_type gbg.temp
scoreboard players reset has_gun_ammo gbg.temp
## GUN RELOAD
# AS AT the reloading player
# Used for ALL guns (except for the ammoless ones of course)

## Canceling if at max Ammo
execute store result score gun_max_ammo gbg.temp run data get entity @s SelectedItem.tag.gun_max_ammo
execute store result score gun_ammo gbg.temp run data get entity @s SelectedItem.tag.gun_ammo
execute if score gun_ammo gbg.temp = gun_max_ammo gbg.temp run return 0


## Removing Ammo from Inventory and Setting Cooldown
data modify storage gbg:ammo ammo_base set from entity @s SelectedItem.tag.gun_ammo_item_base
data modify storage gbg:ammo ammo_tag set from entity @s SelectedItem.tag.gun_ammo_item_tag
execute store result score has_gun_ammo gbg.temp run function gbg:reload/take_ammo with storage gbg:ammo
execute if score has_gun_ammo gbg.temp matches 1 run scoreboard players set @s gbg.cooldown 10
execute if score has_gun_ammo gbg.temp matches 1 run return 0

execute store result score gun_ammo_type gbg.temp run data get entity @s SelectedItem.tag.gun_ammo_type
execute store result score gun_reload_speed gbg.temp run data get entity @s SelectedItem.tag.gun_reload_speed
scoreboard players operation @s gbg.cooldown = gun_reload_speed gbg.temp


## Playing Sound
data modify storage gbg:sounds sound set from entity @s SelectedItem.tag.gun_reload_sound
function gbg:reload/reload_sound with storage gbg:sounds


## Updating Description and Tags
# getting gun stats
execute store result score gun_damage gbg.temp run data get entity @s SelectedItem.tag.gun_damage
execute store result score gun_range gbg.temp run data get entity @s SelectedItem.tag.gun_range
execute store result score gun_fire_rate gbg.temp run data get entity @s SelectedItem.tag.gun_fire_rate
# updating ammo
execute store result score gun_reload_type gbg.temp run data get entity @s SelectedItem.tag.gun_reload_type
execute if score gun_reload_type gbg.temp matches 1 run scoreboard players operation gun_ammo gbg.temp = gun_max_ammo gbg.temp
execute if score gun_reload_type gbg.temp matches 2 run scoreboard players add gun_ammo gbg.temp 1
# updating durability visual
execute if score gun_reload_type gbg.temp matches 1 run scoreboard players set new_damage gbg.temp 0
execute if score gun_reload_type gbg.temp matches 2 run function gbg:calculate_durability
# applying new damage and ammo tags
data modify storage gbg:generic tag set value {}
execute store result storage gbg:generic tag.Damage int 1 run scoreboard players get new_damage gbg.temp
execute store result storage gbg:generic tag.gun_ammo int 1 run scoreboard players get gun_ammo gbg.temp
item modify entity @s weapon.mainhand gbg:general/change_damage
item modify entity @s weapon.mainhand gbg:general/change_ammo
# calculating gun damage for explosive weapons
execute store result score gun_damage_type gbg.temp run data get entity @s SelectedItem.tag.gun_damage_type
execute if score gun_damage_type gbg.temp matches 2..3 run function gbg:calculate_damage
# building lore
item modify entity @s weapon.mainhand gbg:general/remove
item modify entity @s weapon.mainhand gbg:general/ammo
item modify entity @s weapon.mainhand gbg:general/gun_damage
item modify entity @s weapon.mainhand gbg:general/gun_range
item modify entity @s weapon.mainhand gbg:general/fire_rate



